/*
  $VER: GetNET.Thor 2.3b2 (3.12.96)
  by Remco van Hooff

  See GetNET.guide for installation and usage.

  No need to edit anything in this script.
*/

/*!~ "CHANGES IN 2.3"*/
/*!~ "2.3b1"
 - Added URL parsing for the new http button support in Thor.
   Use http.thor to parse the url on to GetNET.
~!*/
/*!~ "2.3b2"
 - Forgot to remove some debug output.
~!*/
/*~!*/

/*!~ "TO DO"
Short term:
  - add the new user database options to GetEmail.

Long term:
 - Rewrite the code layout.
 - Scan selected msgs in one go instead of 1 by 1.
   Note: scan msgs for subject and fromname (more arrays; each msg), save msgs
   to 1 file (add dimention to found/save/name arrays -> difficulty showing all
   in 1 listview: can't show arrays with more than 1 dimention, putting them in
   a special array will lose the msg number info needed for subject/fromname).
   => DIFFICULT!
 - Scanning for FTP and HTTP at once.
   Note: put each line through GetHTTP and GetFTP -> different function calling
   scheme.
 - Hotlist support for other FTP/WWW programs (HOTLIST INFO NEEDED!!!)
 - Show the msg/file that is being scanned in msgwindow (optional), I've
   already tried it but it's just no good when you can't scroll the window when
   an ARexx requester is open :./
   HOW ABOUT ALLOWING TO SCROLL, THOR TEAM???
~!*/

/*---------------------------------------------------------------------------*/

/*!~ "Variables" */
/*!~ "Filters" */
/* don't edit these */
cr = '0d'x
lf = '0a'x
tab= '09'x

/*!~ "trailing filter" */
/* do not use '/' here! */
filter.1.1 = cr
filter.1.2 = lf
filter.1.3 = ')'
filter.1.4 = ','
filter.1.5 = "'"
filter.1.6 = '"'
filter.1.7 = ']'
filter.1.8 = '>'
filter.1.9 = '}'
filter.1.10 = '*'
filter.1.11 = ';' 
filter.1.12 = '`'
filter.1.count = 11 /* number of filters */
/*~!*/

/*!~ "preceeding filter" */
filter.2.1 = '('
filter.2.2 = '"'
filter.2.3 = '<'
filter.2.4 = '['
filter.2.5 = '{'
filter.2.6 = ':'
filter.2.7 = "'"
filter.2.8 = tab
filter.2.9 = '/'
filter.2.10 = '|'
filter.2.11 = '`'
filter.2.count = 11
/*~!*/

/*!~ "filetypes" */
/* for recognition of files in ftp URLs */
/* UPPERCASE */
filetype.1  = '.LZH'
filetype.2  = '.LHA'
filetype.3  = '.LZX'
filetype.4  = '.ZIP'
filetype.5  = '.GZIP'
filetype.6  = '.Z'
filetype.7  = '.GZ'
filetype.8  = '.TAR'
filetype.9  = '.TXT'
filetype.10 = '.FAQ'
filetype.11 = '.README'
filetype.count = 11
/*~!*/
/*~!*/

/*!~ "Constants" */
cfgpath = 'env:thor/'
cfgfile = 'getnet.config'

version = SUBWORD(SOURCELINE(2), 3,1)
maintitle = 'GetNET' version ' by Remco van Hooff'
tempfile = 't:temp.tmp'

EVE_DOWNLOAD     =  4

extra    = 1 

reqfile   = 0
scanhttp  = 0
scanftp   = 0
scanemail = 0

domains = '.EDU.ORG.COM.NET.GOV.MIL.AA.AD.AE.AF.AG.AL.AM.AO.AR.AT.AU.AZ.BA.BB.',
          '.BD.BE.BF.BG.BH.BI.BJ.BM.BN.BO.BR.BS.BT.BW.BY.BZ.CA.CF.CG.CH.CI.CL.',
          '.CM.CN.CO.CR.CU.CV.CY.CZ.DE.DJ.DK.DM.DO.DZ.EC.EE.EG.EP.ES.ET.FI.FJ.',
          '.FR.GA.GB.GD.GE.GH.GM.GN.GQ.GR.GT.GU.GW.GY.HK.HN.HR.HT.HU.ID.IE.IL.',
          '.IN.IQ.IR.IS.IT.JM.JO.JP.KE.KG.KH.KI.KM.KP.KR.KW.KZ.LA.LB.LC.LI.LK.',
          '.LR.LS.LT.LU.LV.LY.MA.MC.MD.MG.ML.MM.MN.MR.MT.MU.MV.MW.MX.MY.MZ.NA.',
          '.NE.NG.NI.NL.NO.NP.NR.NZ.OM.PA.PE.PG.PH.PK.PL.PR.PT.PY.QA.QS.QZ.RO.',
          '.RU.RW.SA.SB.SC.SD.SE.SG.SI.SK.SL.SM.SN.SO.SR.ST.SV.SY.SZ.TD.TG.TH.',
          '.TJ.TM.TN.TO.TR.TT.TV.TW.TZ.UA.UG.UK.US.UY.UZ.VA.VC.VE.VN.VU.WO.WS.',
          '.XA.XC.XD.XE.XF.XH.XI.XJ.XK.XN.XO.XR.XS.XT.XU.XW.XX.XY.XZ.YE.YU.ZA.',
          '.ZM.ZR.ZW.ZZ.INT.'

/*---------------------------------------------------------------------------*/

/*~!*/
/*~!*/

/*!~ "Init" */
ftpsavemode = Upper(ftpsavemode)

OPTIONS RESULTS
OPTIONS FAILAT 31
SIGNAL ON HALT
SIGNAL ON SYNTAX
/*TRACE RESULTS*/

p=' '||ADDRESS()||' '||SHOW('P',,)
IF POS(' THOR.',p)>0 THEN thorport=WORD(SUBSTR(p,POS(' THOR.',p)+1),1)
ELSE DO
  SAY 'THOR port not found!'
  EXIT 10
END

IF ~SHOW('p', 'BBSREAD') THEN DO
  ADDRESS COMMAND
    "run >nil: `GetEnv THOR/THORPath`bin/LoadBBSRead"
    "WaitForPort BBSREAD"
END

IF ~SHOW('L','rexxsupport.library') THEN CALL ADDLIB('rexxsupport.library',0,-30,0)
IF ~SHOW('L','rexxsupport.library') THEN DO
  'REQUESTNOTIFY TEXT "Couldn''t open rexxsupport.library" BT "_Ok"'
  EXIT
END
/*~!*/

/*!~ "Main loop" */
PARSE ARG arguments
template = 'URL/K,REQ/S'

IF arguments = '?' THEN DO
  SAY 'Usage:' template
  EXIT
END

ADDRESS(bbsread)
'READARGS "'template'" 'args' CMDLINE 'arguments
IF RC ~= 0 THEN DO
  SAY BBSREAD.LASTERROR
  SAY 'Template: 'template
  EXIT
END

ADDRESS(thorport)

CALL loadprefs
pro_http = amosaic+aweb+ibrowse+voyager+html+tcpdl
pro_ftp  = ncftp+dopus+guiftp+amftp

IF args.REQ = 1 THEN req = REQ
ELSE req = ''
IF (args.URL ~= '' & args.URL ~= 'ARGS.URL') THEN CALL handle_url(args.URL)
IF askfr = 1 THEN CALL askreq
IF upper(req) = 'REQ' THEN CALL request_file
IF reqfile = 0 THEN CALL getmsg_selected
CALL cleanup
EXIT
/*~!*/

/*!~ "Msg handling" */
/*!~ "getmsg_selected" */
getmsg_selected:
  'GETMSGLISTSELECTED STEM' sel
  SELECT
    WHEN (RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    WHEN ((RC = 3) | (RC = 5)) THEN DO
      CALL current_msg
      CALL msg_info
      CALL main
    END
    OTHERWISE DO
      'CURRENTSYSTEM SYS'
      IF RC = 30 THEN DO
        'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
        CALL cleanup
      END
      IF RC = 1 THEN DO
        'REQUESTNOTIFY TEXT "No open system!" BT "_Ok"'
        CALL cleanup
      END
      curbbs  = SYS.BBSNAME
      curconf = SYS.CONFNAME
      'OPENPROGRESS TITLE "'maintitle'" TOTAL' sel.count 'AT "_Abort" PT "Scanning messages (0/'sel.count')"'
      IF(RC ~= 0) THEN DO
        'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
        CALL cleanup
      END
      ELSE progressid1 = RESULT

      DO multi = 1 TO sel.COUNT
        'UPDATEPROGRESS REQ' progressid1 'CURRENT' multi 'PT "Scanning messages ('multi'/'sel.count')"'
        IF RC = 5 THEN CALL cleanup 
        IF(RC = 30) THEN DO
          'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
          CALL cleanup
        END
        msgnum = sel.multi
        CALL msg_info 
        CALL main 
      END
      'CLOSEPROGRESS REQ' progressid1
    END
  END
RETURN
/*~!*/

/*!~ "current_msg" */
current_msg:
  'CURRENTMSG stem' MSG
  IF(RC ~= 0) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  msgnum  = MSG.MSGNR
  curbbs  = MSG.BBSNAME
  curconf = MSG.CONFNAME
RETURN
/*~!*/

/*!~ "msg_info" */
msg_info:
  ADDRESS bbsread 'READBRMESSAGE BBSNAME "'curbbs'" CONFNAME "'curconf'" MSGNR' msgnum 'HEADSTEM' headtags
  IF(RC ~= 0) THEN DO
    'REQUESTNOTIFY TEXT "'BBSREAD.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  fromname = HEADTAGS.FROMNAME
  subj = HEADTAGS.SUBJECT
  IF POS('RE:',UPPER(subj)) ~=0 THEN subj = SUBSTR(subj,5)
RETURN
/*~!*/

/*!~ "main" */
main:
  DROP FOUND. SAVE. NAME.
  IF (scanhttp = 0 & scanftp = 0 & scanemail = 0) THEN DO
    'REQUESTNOTIFY TEXT "Select a URL to scan for." BT "_HTTP|_Email|_FTP|_Aminet|_Quit"'
    SELECT
      WHEN RESULT = 1 THEN scanhttp = 1
      WHEN RESULT = 2 THEN scanemail = 1
      WHEN RESULT = 3 THEN scanftp = 1
      WHEN RESULT = 4 THEN scanaminet = 1
      OTHERWISE CALL cleanup
    END
  END  
  SELECT
    WHEN scanhttp = 1 THEN CALL get_http
    WHEN scanemail = 1 THEN CALL get_email
    WHEN scanftp = 1 THEN CALL get_ftp
    WHEN scanaminet = 1 THEN CALL get_aminet
    OTHERWISE NOP
  END
RETURN
/*~!*/
/*~!*/

/*!~ "GetHTTP" */
/*!~ "get_http" */
get_http:
  'OPENPROGRESS TITLE "'maintitle'" TOTAL 0 AT "_Abort" PT "Hold on, saving message..."'
  IF(RC ~= 0) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  ELSE progressid = RESULT
  IF reqfile = 0 THEN DO
    'SAVEMESSAGE BBSNAME "'curbbs'" CONFNAME "'curconf'" MSGNR' msgnum 'FILENAME' tempfile 'NOANSI OVERWRITE'
    IF(RC ~= 0) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
  END
  CALL gethttp
  CALL listfound
  IF ok = 1 THEN CALL listsave(1)
RETURN
/*~!*/

/*!~ "gethttp" */
gethttp:
  opentmp = OPEN(tmp, tempfile, 'R')
  filelngth = SEEK(tmp,0,'E')
  'UPDATEPROGRESS REQ' progressid 'TOTAL' filelngth 'PT "Searching... (0)"'
  IF RC = 5 THEN CALL cleanup 
  IF(RC = 30) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  CALL SEEK(tmp, 0,'B')
  num = 0; found.count = 0; sumadres = ''; curpos = 0
  DO UNTIL curpos = filelngth
    msg = READLN(tmp)
    curpos = SEEK(tmp, 0)
    IF curpos // 10 = 0 THEN 'UPDATEPROGRESS REQ' progressid 'CURRENT' curpos
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    httpadres = ''
    DO FOREVER
      IF ((POS('WWW', UPPER(msg)) ~= 0) & (POS('TTP://', UPPER(msg)) ~= POS('WWW', UPPER(msg)) - 6))  THEN DO
        msg1 = OVERLAY('www', msg, POS('WWW',UPPER(msg)))
        PARSE VAR msg1 . 'www' httpadres rest
        IF httpadres ~= '' THEN httpadres = 'www'||httpadres
      END
      ELSE DO
        IF POS('HTTP://', UPPER(msg)) ~= 0 THEN DO
          msg1 = OVERLAY('http', msg, POS('HTTP://',UPPER(msg)))
          PARSE VAR msg1 . 'http://' httpadres rest
        END
      END
      IF httpadres ~= '' THEN DO
        CALL filter(httpadres,1)
        httpadres = 'http://'||RESULT
        CALL checkdomain(httpadres, 'HTTP')
        PARSE VAR httpadres 'http://' num1 '.' num2 '.' num3 '.' num4
        IF (DATATYPE(num1, 'NUM') & DATATYPE(num2, 'NUM') & DATATYPE(num3, 'NUM') & num4 ~= '') THEN domainOK = 1
        CALL dubbel(httpadres,0)
      END
      IF (POS('HTTP://', UPPER(rest)) ~= 0 | POS('WWW', UPPER(rest)) ~= 0) THEN DO
        msg = rest
        empty = 0
      END 
      ELSE empty = 1
      IF empty = 1 THEN LEAVE
    END
  END
  'CLOSEPROGRESS REQ' progressid
  CALL CLOSE(tmp)
  IF reqfile = 0 THEN DELETE(tempfile)
RETURN
/*~!*/
/*~!*/

/*!~ "GetEmail" */
/*!~ "get_email" */
get_email:
  'OPENPROGRESS TITLE "'maintitle'" TOTAL 0 AT "_Abort" PT "Hold on, saving message..."'
  IF(RC ~= 0) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  ELSE progressid = RESULT
  IF reqfile = 0 THEN DO
    'SAVEMESSAGE BBSNAME "'curbbs'" CONFNAME "'curconf'" MSGNR' msgnum 'FILENAME' tempfile 'NOHEADER NOANSI OVERWRITE'
    IF(RC ~= 0) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
  END
  CALL getemail
  CALL listfound
  IF ok = 1 THEN CALL listsave(2)
RETURN
/*~!*/

/*!~ "getemail" */
getemail:
  opentmp = OPEN(tmp, tempfile, 'r')
  filelngth = SEEK(tmp,0,'E')
  'UPDATEPROGRESS REQ' progressid 'TOTAL' filelngth 'PT "Searching... (0)"'
  IF RC = 5 THEN CALL cleanup 
  IF(RC = 30) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  CALL SEEK(tmp, 0,'B')
  num = 0; found.count = 0; sumadres = ''; curpos = 0
  DO UNTIL curpos = filelngth
    msg = READLN(tmp)
    curpos = SEEK(tmp, 0)
    IF curpos // 10 = 0 THEN 'UPDATEPROGRESS REQ' progressid 'CURRENT' curpos
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    PARSE VAR msg part1 '@' part2 '.' part3 rest
    DO FOREVER
      IF (part2 ~= '' & POS(' ',part2) = 0 & part3 ~= '') THEN DO
        spc = LASTPOS(' ', part1)
        IF spc ~= 0 THEN part1 = DELSTR(part1, 1, spc)
        CALL filter(part1,2)
        part1 = RESULT
        CALL filter(part3,1)
        part3 =  RESULT
        email = part1'@'part2'.'adres
        CALL dubbel(email, 1)
      END
      IF POS('@', rest) ~= 0 THEN DO
        PARSE VAR rest part1 '@' part2 '.' part3 rest
        empty = 0
      END 
      ELSE empty = 1
      IF empty = 1 THEN LEAVE
    END
  END
  'CLOSEPROGRESS REQ' progressid
  CALL CLOSE(tmp)
  IF reqfile = 0 THEN DELETE(tempfile)
RETURN
/*~!*/

/*!~ "userdata" */
userdata:
  IF alias.n = 'ALIAS.'n THEN alias.n = ''
  IF comm.n  = 'COMM.'n  THEN comm.n  = ''
  showdata.1 = 'name    :' name.n
  showdata.2 = 'address :' save.n
  showdata.3 = 'alias   :' alias.n
  showdata.4 = 'comment :' comm.n
  showdata.5 = ''
  showdata.6 = 'RETURN'
  showdata.count = 6
  titel = 'Userdata for' save.n
  'REQUESTLIST INSTEM' showdata 'TITLE "'titel'" SIZEGADGET'
  IF (RC = 30) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  IF RC ~= 5 THEN DO
    sel = RESULT
    IF sel = showdata.1 THEN DO
      RESULT = name.n
      'REQUESTSTRING TITLE "Enter a name for" BT "_OK|_From:|_Cancel" BODY "'save.n'" INITIALSTRING "'name.n'"'
      IF THORRC = 0 then name.n = ''
      IF THORRC = 1 then name.n = RESULT
      IF THORRC = 2 THEN name.n = fromname
    END
    IF sel = showdata.2 THEN DO
      RESULT = save.n
      'REQUESTSTRING TITLE "Change address" BT "_OK|_Cancel" BODY "'save.n'" INITIALSTRING "'save.n'"'
      save.n = RESULT
    END
    IF sel = showdata.3 THEN DO
      RESULT = alias.n
      'REQUESTSTRING TITLE "Enter an alias for" BT "_OK|_Cancel" BODY "'save.n'" INITIALSTRING "'alias.n'"'
      alias.n = RESULT
    END
    IF sel = showdata.4 THEN DO
      RESULT = comm.n
      'REQUESTSTRING TITLE "Enter a comment for" BT "_OK|_Cancel" BODY "'save.n'" INITIALSTRING "'comm.n'"'
      comm.n = RESULT
    END
    IF sel = 'RETURN' THEN SIGNAL listsave(2)
    SIGNAL userdata
  END
RETURN
/*~!*/

/*!~ "save_userdata" */
save_userdata:
  DROP USER.
  DO i = 1 TO save.count
    IF name.i = '' THEN DO
      PARSE VAR save.i part1 '@'
      name.i = part1
    END
    USER.NAME      = name.i
    USER.ADDRESS   = save.i
    USER.ALIAS     = alias.i
    USER.COMMENT.1 = comm.i
    IF USER.COMMENT.1 = '' THEN USER.COMMENT.COUNT = 0
    ELSE USER.COMMENT.COUNT = 1
    ADDRESS BBSREAD 'WRITEBRUSER BBSNAME "'bbs'" STEM USER ONLYIFEXIST'
    IF RC~=0 THEN DO
      'REQUESTNOTIFY TEXT "'BBSREAD.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
  END
RETURN
/*~!*/
/*~!*/

/*!~ "GetFTP" */
/*!~ "get_ftp" */
get_ftp:
  'OPENPROGRESS TITLE "'maintitle'" TOTAL 0 AT "_Abort" PT "Hold on, saving message..."'
  IF(RC ~= 0) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  ELSE progressid = RESULT
  IF reqfile = 0 THEN DO
    'SAVEMESSAGE BBSNAME "'curbbs'" CONFNAME "'curconf'" MSGNR' msgnum 'FILENAME' tempfile 'NOHEADER NOANSI OVERWRITE'
    IF(RC ~= 0) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
  END
  CALL getftp
  CALL listfound
  IF ok = 1 THEN CALL listsave(1)
RETURN
/*~!*/

/*!~ "getftp" */
getftp:
  opentmp = OPEN(tmp, tempfile, 'R')
  filelngth = SEEK(tmp,0,'E')
  'UPDATEPROGRESS REQ' progressid 'TOTAL' filelngth 'PT "Searching... (0)"'
  IF RC = 5 THEN CALL cleanup 
  IF(RC = 30) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
     CALL cleanup
  END
  CALL SEEK(tmp, 0,'B')
  num = 0; found.count = 0; sumadres = ''; curpos = 0
  DO UNTIL curpos = filelngth
    msg = READLN(tmp)
    curpos = SEEK(tmp, 0)
    IF curpos // 10 = 0 THEN 'UPDATEPROGRESS REQ' progressid 'CURRENT' curpos
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    IF POS('FTP://', UPPER(msg)) ~=0 THEN DO
      CALL getftp2
    END
    IF extra = 1 THEN DO
      CALL getip
    END
  END
  'CLOSEPROGRESS REQ' progressid
  CALL CLOSE(tmp)
  IF reqfile = 0 THEN DELETE(tempfile)
RETURN
/*~!*/

/*!~ "getftp2" */
getftp2:
  msg2 = OVERLAY('ftp', msg, POS('FTP://',UPPER(msg)))
  PARSE VAR msg2 . 'ftp://' ftpadres rest
  DO FOREVER    
    IF ftpadres ~= '' THEN DO
      CALL filter(ftpadres,1)
      ftpadres = 'ftp://'||RESULT
      CALL checkdomain(ftpadres, 'FTP')
      CALL dubbel(ftpadres, 0)
    END
    IF POS('FTP://', UPPER(rest)) ~= 0 THEN DO
      msg2 = OVERLAY('ftp', rest, POS('FTP://',UPPER(rest)))
      PARSE VAR msg2 . 'ftp://' ftpadres rest
      empty = 0
    END 
    ELSE empty = 1
    IF empty = 1 THEN LEAVE
  END
RETURN
/*~!*/

/*!~ "getip" */
getip:
  msg2 = SPACE(msg,1,'|')
  PARSE VAR msg2 part1'.'part2'|'rest
  DO FOREVER
    domainOK = 0
    IF (POS('HTTP://',UPPER(part1))~=0) THEN LEAVE
    IF ((part2 ~= '' & POS('|',part2) = 0) & (length(part1)>1 & length(part2)>1)) THEN DO
      CALL filter(part1,2)
      part1 = RESULT
      CALL filter(part2,1)
      part2 =  RESULT
      ftpadres = 'ftp://'part1'.'part2
      IF (pos('@',ftpadres) = 0 & pos('www', ftpadres) = 0 & LENGTH(part2) >= 2 & pos('..', ftpadres) = 0) THEN DO
        part2 = '.'part2
        CALL checkdomain(ftpadres, 'IP')
        IF DATATYPE(part1, 'NUM') THEN DO
          PARSE VAR ftpadres 'ftp://' num1 '.' num2 '.' num3 '.' num4
          IF (DATATYPE(num1, 'NUM') & DATATYPE(num2, 'NUM') & DATATYPE(num3, 'NUM') & num4 ~= '') THEN domainOK = 1
        END
      CALL dubbel(ftpadres, 0)
      END
    END
    IF POS('.', rest) ~= 0 THEN DO
      PARSE VAR rest part1'.'part2'|'rest
      empty = 0
    END
    ELSE empty = 1
    IF empty = 1 THEN LEAVE
  END
RETURN
/*~!*/
/*~!*/

/*!~ "GetAminet" */
/*!~ "get_aminet" */
get_aminet:
  'OPENPROGRESS TITLE "'maintitle'" TOTAL 0 AT "_Abort" PT "Hold on, saving message..."'
  IF(RC ~= 0) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  ELSE progressid = RESULT
  IF reqfile = 0 THEN DO
    'SAVEMESSAGE BBSNAME "'curbbs'" CONFNAME "'curconf'" MSGNR' msgnum 'FILENAME' tempfile 'NOANSI OVERWRITE NOHEADER'
    IF(RC ~= 0) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
  END
  CALL getaminet
  CALL listfound
  IF ok = 1 THEN CALL create_dlevent
RETURN
/*~!*/

/*!~ "getaminet" */
getaminet:
  opentmp = OPEN(tmp, tempfile, 'R')
  filelngth = SEEK(tmp,0,'E')
  'UPDATEPROGRESS REQ' progressid 'TOTAL' filelngth 'PT "Searching... (0)"'
  IF RC = 5 THEN CALL cleanup
  IF(RC = 30) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
     CALL cleanup
  END
  CALL SEEK(tmp, 0,'B')
  num = 0; found.count = 0; sumadres = ''; curpos = 0
  DO UNTIL curpos = filelngth
    msg = READLN(tmp)
    curpos = SEEK(tmp, 0)
    IF curpos // 10 = 0 THEN 'UPDATEPROGRESS REQ' progressid 'CURRENT' curpos
    IF RC = 5 THEN CALL cleanup
    IF RC = 30 THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    IF RC = 0 THEN DO
      PARSE VAR msg 1 file 20 dir1'/'dir2 .
      file = strip(file)
      dir = strip(dir1'/'dir2)
      IF (POS('AHL.', UPPER(REVERSE(file))) = 1 | POS('SMD.', UPPER(REVERSE(file))) = 1 | POS('HZL.', UPPER(REVERSE(file))) = 1) THEN DO
        aminetfile = LEFT(file,20, ' ')||'('||dir||')'
        CALL dubbel(aminetfile,1)
        curpos = SEEK(tmp, 0)
      END
    END
  END
  'CLOSEPROGRESS REQ' progressid
  CALL CLOSE(tmp)
  IF reqfile = 0 THEN DELETE(tempfile)
RETURN
/*~!*/
/*~!*/

/*!~ "Save hotlists" */
/*!~ "savehotlist" */
savehotlist:
  IF scanhttp = 1 THEN savetotal = pro_http
  IF (scanftp = 1 & ftpsavemode = 'W') THEN savetotal = pro_http
  IF (scanftp = 1 & ftpsavemode = 'B') THEN savetotal = pro_http + pro_ftp
  IF (scanftp = 1 & ftpsavemode = 'F') THEN savetotal = pro_ftp

  DO sv = 1 TO save.count
    IF name.sv = '' THEN name.sv = subj '('sv')'
  END
  'OPENPROGRESS TITLE "'maintitle'" TOTAL' savetotal ' PT "Saving addresses..."'
  IF(RC ~= 0) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  ELSE pbsave = RESULT

  IF amosaic = 1 THEN DO
    IF (scanftp = 1 & (ftpsavemode = 'W' | ftpsavemode = 'B')) THEN CALL save_amosaic
    IF scanftp = 0 THEN CALL save_amosaic
  END
  IF ibrowse = 1 THEN DO
    IF (scanftp = 1 & (ftpsavemode = 'W' | ftpsavemode = 'B')) THEN CALL save_ibrowse
    IF scanftp = 0 THEN CALL save_ibrowse
  END
  IF html    = 1 THEN DO
    IF (scanftp = 1 & (ftpsavemode = 'W' | ftpsavemode = 'B')) THEN CALL save_html
    IF scanftp = 0 THEN CALL save_html
  END
  IF aweb    = 1 THEN DO
    IF (scanftp = 1 & (ftpsavemode = 'W' | ftpsavemode = 'B')) THEN CALL save_aweb
    IF scanftp = 0 THEN CALL save_aweb
  END
  IF voyager = 1 THEN DO
    IF (scanftp = 1 & (ftpsavemode = 'W' | ftpsavemode = 'B')) THEN CALL save_voyager
    IF scanftp = 0 THEN CALL save_voyager
  END
  IF tcpdl = 1 THEN DO
    IF (scanftp = 1 & (ftpsavemode = 'W' | ftpsavemode = 'B')) THEN CALL save_tcpdl
    IF scanftp = 0 THEN CALL save_tcpdl
  END
  IF (ncftp   = 1 & scanftp = 1 & (ftpsavemode = 'F' | ftpsavemode = 'B')) THEN CALL save_ncftp
  IF (dopus   = 1 & scanftp = 1 & (ftpsavemode = 'F' | ftpsavemode = 'B')) THEN CALL save_dopus
  IF (guiftp  = 1 & scanftp = 1 & (ftpsavemode = 'F' | ftpsavemode = 'B')) THEN CALL save_guiftp
  IF (amftp   = 1 & scanftp = 1 & (ftpsavemode = 'F' | ftpsavemode = 'B')) THEN CALL save_amftp
  'CLOSEPROGRESS REQ' pbsave
  IF pro_http + pro_ftp = 0 THEN 'REQUESTNOTIFY "No hotlist(s) configured.\nUse CfgGetNET to configure them." "_OK"'
RETURN
/*~!*/

/*!~ "save_amosaic" */
save_amosaic:
  IF ~EXISTS(hotlist_amosaic) THEN DO
    'REQUESTNOTIFY "Amosaic hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    'UPDATEPROGRESS REQ' pbsave 'CURRENT' amosaic 'PT "Saving to AMosaic..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    dat = DATE()
    PARSE VAR dat dagnr maand jaar
    dag = LEFT(DATE('W', DATE(S), 'S'), 3)
    datum = dag maand dagnr TIME()jaar
    CALL OPEN(htlst,hotlist_amosaic,'a')
    DO sa = 1 TO save.count
      CALL WRITELN(htlst,save.sa||' '||datum)
      CALL WRITELN(htlst,STRIP(name.sa))
    END
    CALL CLOSE(htlst)
  END
  ADDRESS COMMAND 'copy' hotlist_amosaic 'env:mosaic/ quiet'
RETURN
/*~!*/

/*!~ "save_ibrowse" */
save_ibrowse:
  IF ~EXISTS(hotlist_ibrowse) THEN DO
    'REQUESTNOTIFY "IBrowse hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    'UPDATEPROGRESS REQ' pbsave 'CURRENT' amosaic+ibrowse 'PT "Saving to IBrowse..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(in,hotlist_ibrowse,'r')
    CALL OPEN(out,'t:IBrowse.tmp','w')
      line = READLN(in)
      DO UNTIL line = '<UL>'
        WRITELN(out, line)
        line = READLN(in)
      END
      WRITELN(out, line)
      DO si = 1 TO save.count
        adres = '<LI><A HREF="'||save.si||'">'STRIP(name.si)'</A><br>'
        WRITELN(out, adres)
      END
      DO UNTIL EOF(in)
        rest = readch(in,1048576)
        WRITECH(out, rest)
      END
    CALL CLOSE(out)
    CALL CLOSE(in)
    ADDRESS COMMAND 'copy t:ibrowse.tmp' hotlist_ibrowse 'quiet'
    DELETE('t:ibrowse.tmp')
  END
RETURN
/*~!*/

/*!~ "save_html" */
save_html:
  IF ~EXISTS(hotlist_html) THEN DO
    'REQUESTNOTIFY "HTML hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    'UPDATEPROGRESS REQ' pbsave 'CURRENT' amosaic+ibrowse+html 'PT "Saving to HTML..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(htlst,hotlist_html,'a')
    DO sh = 1 TO save.count
      CALL WRITELN(htlst,'<LI><A HREF="'save.sh'">'STRIP(name.sh)'</A><br>')
    END
    CALL CLOSE(htlst)
  END
RETURN
/*~!*/

/*!~ "save_aweb" */
save_aweb:
  IF ~EXISTS(hotlist_aweb) THEN DO
    'REQUESTNOTIFY "AWeb hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    'UPDATEPROGRESS REQ' pbsave 'CURRENT' amosaic+ibrowse+html+aweb 'PT "Saving to AWeb..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(htlst,hotlist_aweb,'a')
    DO sw = 1 TO save.count
      CALL WRITELN(htlst,save.sw)
      CALL WRITELN(htlst,STRIP(name.sw))
    END
    CALL CLOSE(htlst)
  END
RETURN
/*~!*/

/*!~ "save_voyager" */
save_voyager:
  IF ~EXISTS(hotlist_voyager) THEN DO
    'REQUESTNOTIFY "Voyager hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    'UPDATEPROGRESS REQ' pbsave 'CURRENT' amosaic+ibrowse+html+aweb+voyager 'PT "Saving to Voyager..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(in,hotlist_voyager,'r')
    CALL OPEN(out,'t:voyager.tmp','w')
      line = READLN(in)
      DO UNTIL line = '<UL>'
        WRITELN(out, line)
        line = READLN(in)
      END
      WRITELN(out, line)
      DO vo = 1 TO save.count
        adres = '<LI><A HREF="'||save.vo||'">'STRIP(name.vo)'</A><br>'
        WRITELN(out, adres)
      END
      DO UNTIL EOF(in)
        rest = readch(in,1048576)
        WRITECH(out, rest)
      END
    CALL CLOSE(out)
    CALL CLOSE(in)
    ADDRESS COMMAND 'copy t:voyager.tmp' hotlist_voyager 'quiet'
   DELETE('t:voyager.tmp')
  END
RETURN
/*~!*/

/*!~ "save_tcpdl"*/
save_tcpdl:
  IF ~EXISTS(hotlist_tcpdl) THEN DO
    'REQUESTNOTIFY "TCPdl hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    'UPDATEPROGRESS REQ' pbsave 'CURRENT' amosaic+aweb+ibrowse+voyager+html+tcpdl 'PT "Saving to TCPdl..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(out,hotlist_tcpdl,'a')
      DO tl = 1 TO save.count
        adres = pre_tcpdl||save.tl||' 'suf_tcpdl
        WRITELN(out, adres)
      END
    CALL CLOSE(out)
  END
RETURN
/*~!*/

/*!~ "save_ncftp" */
save_ncFTP:
  IF ~EXISTS(hotlist_ncftp) THEN DO
    'REQUESTNOTIFY "ncFTP hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    IF ftpsavemode = 'F' THEN pro_cur = ncftp
    IF ftpsavemode = 'B' THEN pro_cur = pro_http + ncftp

    'UPDATEPROGRESS REQ' pbsave 'CURRENT' pro_cur 'PT "Saving to ncFTPrecent..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(in,hotlist_ncftp,'r')
    CALL OPEN(out,'t:ncftp.tmp','w')
    CALL convdate
      DO nc = 1 TO save.count
        CALL prepftp(save.nc)
        adres = LEFT(ftpadr,34,' ') now ftpdir
        WRITELN(out, adres)
      END
      DO UNTIL EOF(in)
        rest = readch(in,1048576)
        WRITECH(out, rest)
      END
    CALL CLOSE(out)
    CALL CLOSE(in)
    ADDRESS COMMAND 'copy t:ncftp.tmp' hotlist_ncftp 'quiet'
   DELETE('t:ncftp.tmp')
  END
RETURN
/*~!*/

/*!~ "save_dopus" */
save_dopus:
  IF ~EXISTS(hotlist_dopus) THEN DO
    'REQUESTNOTIFY "DOpusFTP hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    IF ftpsavemode = 'F' THEN pro_cur = ncftp+dopus
    IF ftpsavemode = 'B' THEN pro_cur = pro_http + ncftp + dopus

    'UPDATEPROGRESS REQ' pbsave 'CURRENT' pro_cur 'PT "Saving to DOpusFTP..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(in,hotlist_dopus,'a')
      DO dp = 1 TO save.count
        CALL prepftp(save.dp)
        IF ftpsitename THEN name.dp = ftpadr
        IF ftpfile = '' THEN ftpname = name.dp
        ELSE ftpname = name.dp '('ftpfile')'
        PARSE VAR ftpadr tstnum '.'
        IF DATATYPE(tstnum, 'NUM') THEN adres = 'anon alias="'ftpname'" addr="'ftpadr'" dir="'ftpdir'"'
        ELSE adres = 'anon alias="'ftpname'" host="'ftpadr'" dir="'ftpdir'"'
        WRITELN(in, adres)
      END
    CALL CLOSE(in)
  END
RETURN
/*~!*/

/*!~ "save_guiftp" */
save_guiftp:
  IF ~EXISTS(hotlist_guiftp) THEN DO
    'REQUESTNOTIFY "GUI-FTP hotlist not found!" "_OK"'
    RETURN
  END
  ELSE DO
    IF ftpsavemode = 'F' THEN pro_cur = ncftp+dopus+guiftp
    IF ftpsavemode = 'B' THEN pro_cur = pro_http + ncftp + dopus + guiftp

    'UPDATEPROGRESS REQ' pbsave 'CURRENT' pro_cur 'PT "Saving to GUI-FTP..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    CALL OPEN(in, hotlist_guiftp, 'A')
      DO gf = 1 TO save.count
        CALL prepftp(save.gf)
        IF ftpsitename THEN name.gf = ftpadr
        IF ftpfile ~= '' THEN ftpname = name.gf '('ftpfile')'
        ELSE ftpname = name.gf
        WRITELN(in, 'machine' ftpadr)
        WRITELN(in, ' description' ftpname)
        WRITELN(in, ' dir' ftpdir)
        WRITELN(in, ' anonftp')
        WRITELN(in, '')
      END
    CALL CLOSE(in)
  END
RETURN
/*~!*/

/*!~ "save_amftp" */
save_amftp:
  IF ~SHOW('p', 'AMFTP.1') THEN DO
    'REQUESTNOTIFY TEXT "AmFTP is not running.\n\nTo save the addresses to the AmFTP\nhotlist AmFTP needs to be running.\n\nStart AmFTP?" BT "_Yes|_No"'
    IF RC = 0 THEN DO
      IF RESULT = 1 THEN DO
        IF ~EXISTS(path_amftp) THEN DO
          'REQUESTNOTIFY TEXT "AmFTP not found." BT "_OK"'
          RETURN
        END
        ELSE DO
          IF ~SHOWLIST('L','bsdsocket.library') THEN DO
             ADDRESS COMMAND tcp_ip
             IF SHOWLIST('L','bsdsocket.library') THEN CALL run_amftp
             ELSE DO
               'REQUESTNOTIFY TEXT "No bsdsocket.library found.\n\nCan''t save to AmFTP hotlist" BT "_OK"'
             END
          END
          ELSE DO
            CALL run_amftp
          END
        END
      END
      IF RESULT = 0 THEN RETURN
    END
  END

  IF SHOW('p', 'AMFTP.1') THEN DO
    IF ftpsavemode = 'F' THEN pro_cur = ncftp+dopus+guiftp+amftp
    IF ftpsavemode = 'B' THEN pro_cur = pro_http+ncftp+dopus+guiftp+amftp

    ADDRESS(thorport)
    'THORTOFRONT'
    'UPDATEPROGRESS REQ' pbsave 'CURRENT' pro_cur 'PT "Saving to AmFTP..."'
    IF RC = 5 THEN CALL cleanup
    IF(RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    ADDRESS AMFTP.1
    DO af = 1 TO save.count
      CALL prepftp(save.af)
      IF ftpsitename THEN name.af = ftpadr
      IF ftpfile ~= '' THEN ftpname = name.af '('ftpfile')'
      ELSE ftpname = name.af
      STEM.HOST     = ftpadr
      STEM.PORT     = 21
      STEM.ADT      = 0
      STEM.ANON     = 1
      STEM.DEFDIR   = ftpdir
      'CREATEPROFILE "'ftpname'"'
      'SETPROFILE' RESULT STEM
    END
    'SAVEPROFILES'
    ADDRESS(thorport)
  END
  ELSE DO
    'REQUESTNOTIFY TEXT "AmFTP is not running.\n\nCould not save to AmFTP." BT "_OK"'
  END
RETURN
/*~!*/

/*!~ "run_amftp" */
run_amftp:
  ADDRESS COMMAND
    'run <>nil:' path_amftp
    'WaitForPort AMFTP.1'
RETURN
/*~!*/

/*!~ "prepftp" */
prepftp:
  tmpftp = ARG(1)
  ftpfile = ''
  tmpftp = TRANSLATE(tmpftp, '/', ':')
  PARSE VAR tmpftp 'ftp///' ftpadr '/' ftpdir
  CALL filter(ftpadr,2)
  ftpadr = RESULT
  IF ftpdir = '' THEN ftpdir = '/'
  IF (ftpdir ~= '' & (dopus = 1 | guiftp = 1 | amftp = 1)) THEN DO
    IF LASTPOS('/', ftpdir) < LENGTH(ftpdir) THEN DO
      DO ft = 1 TO filetype.count
        IF POS(filetype.ft, UPPER(ftpdir)) ~= 0 THEN DO
          ftpfile = SUBSTR(ftpdir, (LASTPOS('/', ftpdir) + 1))
          ftpdir = SUBSTR(ftpdir, 1, LASTPOS('/', ftpdir))
        END
      END
    END
  END
RETURN
/*~!*/

/*!~ "convdate" */
convdate:
  DROP dat.
  datum = Date('S')
  tijd  = time('N')
  dat.HOUR  = SUBSTR(tijd,1,2)
  dat.MIN   = SUBSTR(tijd,4,2)
  dat.SEC   = SUBSTR(tijd,7,2)
  dat.YEAR  = SUBSTR(datum,1,4)
  dat.MONTH = SUBSTR(datum,5,2)
  dat.MDAY  = SUBSTR(datum,7,2)
  ADDRESS BBSREAD DATE2AMIGA dat
  now = RESULT
RETURN
/*~!*/
/*~!*/

/*!~ "Misc functions" */
/*!~ "LoadPrefs" */
loadprefs:
  IF ~EXISTS(cfgpath||cfgfile) THEN DO
    Address(thorport)
    'Requestnotify TEXT "Could not find the configuration file.\nRun CfgGetNET to create one." BT "_OK"'
    EXIT
  END
  ELSE DO
    CALL OPEN(prf,cfgpath||cfgfile,'R')
      DO UNTIL EOF(prf)
        line = READLN(prf)
        SELECT
          WHEN UPPER(WORD(line,1)) = 'BBS' THEN DO
            bbs = SUBWORD(line,2)
          END
          WHEN UPPER(WORD(line,1)) = 'ASKFR' THEN DO
            askfr = WORD(line,2)
          END
          WHEN Upper(Word(line,1)) = 'REQDIR' THEN DO
            reqdir = SubWord(line,2)
          END
          WHEN Upper(Word(line,1)) = 'FTPSAVEMODE' THEN DO
            ftpsavemode = UPPER(WORD(line,2))
          END
          WHEN Upper(Word(line,1)) = 'FTPSITENAME' THEN DO
            ftpsitename = UPPER(WORD(line,2))
          END
          WHEN UPPER(WORD(line,1)) = 'AMOSAIC' THEN DO
            hotlist_amosaic = WORD(line,2)
            amosaic = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'AWEB' THEN DO
            hotlist_aweb = WORD(line,2)
            aweb = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'IBROWSE' THEN DO
            hotlist_ibrowse = WORD(line,2)
            ibrowse = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'VOYAGER' THEN DO
            hotlist_voyager = WORD(line,2)
            voyager = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'HTML' THEN DO
            hotlist_html = WORD(line,2)
            html = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'NCFTP' THEN DO
            hotlist_ncftp = WORD(line,2)
            ncftp = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'DOPUS' THEN DO
            hotlist_dopus = WORD(line,2)
            dopus = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'GUIFTP' THEN DO
            hotlist_guiftp = WORD(line,2)
            guiftp = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'AMFTP' THEN DO
            path_amftp = WORD(line,2)
            amftp = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'TCPDL' THEN DO
            hotlist_tcpdl = WORD(line,2)
            tcpdl = WORD(line,3)
          END
          WHEN UPPER(WORD(line,1)) = 'TCPDL_PRE' THEN DO
            pre_tcpdl = SUBWORD(line,2)
          END
          WHEN UPPER(WORD(line,1)) = 'TCPDL_SUF' THEN DO
            suf_tcpdl = SUBWORD(line,2)
          END
          WHEN UPPER(WORD(line,1)) = 'TCP-IP' THEN DO
            tcp_ip = SUBWORD(line,2)
          END
          OTHERWISE NOP
        END
      END
    CALL CLOSE(prf)
    CALL checkprefs
  END
RETURN
/*~!*/

/*!~ "CheckPrefs" */
checkprefs:
  IF ~DATATYPE(askfr, 'BIN')       THEN CALL prefserror('ASKFR')
  IF ~DATATYPE(ftpsavemode, 'ALP') THEN CALL prefserror('FTPSAVEMODE')
  IF ~DATATYPE(ftpsitename, 'BIN') THEN CALL prefserror('FTPSITENAME')
  IF ~DATATYPE(amosaic, 'BIN')     THEN CALL prefserror('AMOSAIC')
  IF ~DATATYPE(aweb, 'BIN')        THEN CALL prefserror('AWEB')
  IF ~DATATYPE(ibrowse, 'BIN')     THEN CALL prefserror('IBROWSE')
  IF ~DATATYPE(voyager, 'BIN')     THEN CALL prefserror('VOYAGER')
  IF ~DATATYPE(html, 'BIN')        THEN CALL prefserror('HTML')
  IF ~DATATYPE(ncftp, 'BIN')       THEN CALL prefserror('NCFTP')
  IF ~DATATYPE(dopus, 'BIN')       THEN CALL prefserror('DOPUS')
  IF ~DATATYPE(guiftp, 'BIN')      THEN CALL prefserror('GUIFTP')
  IF ~DATATYPE(amftp, 'BIN')       THEN CALL prefserror('AMFTP')
  IF ~DATATYPE(tcpdl, 'BIN')       THEN CALL prefserror('TCPDL')
RETURN
/*~!*/

/*!~ "PrefsError" */
prefserror:
  prferr = ARG(1)
  ADDRESS(thorport)
  'REQUESTNOTIFY TEXT "The config file is not in the\ncorrect format. An error occured at\nor before 'prferr'.\nPlease run CfgGetNET to correct this.\n\nIf the problem remains, contact\nthe author at rvhooff@caiw.nl" BT "_OK"'
  CALL cleanup
RETURN
/*~!*/

/*!~ "Filter" */
filter:
  PARSE ARG adres,fltr
  lngth = LENGTH(adres)
  IF fltr = 2 THEN adres=REVERSE(adres)
  DO i = 1 TO filter.fltr.count
    check = POS(filter.fltr.i, adres)
    IF check ~=0 THEN adres = DELSTR(adres, check)
  END
  punt = LASTPOS('.', adres)
  IF punt ~=0 THEN lngth = length(adres)
  IF (punt = lngth) THEN adres = DELSTR(adres, punt)
  IF fltr = 2 THEN adres=REVERSE(adres)
RETURN(adres)
/*~!*/

/*!~ "ListFound" */
listfound:
  IF found.COUNT > 0 THEN DO
    IF scanaminet = 1 THEN foundtitel = 'Select files to download.'
    ELSE foundtitel = 'Select address(es) to save.'
    'REQUESTLIST INSTEM' found 'OUTSTEM' save 'TITLE "'foundtitel' Total: 'num'" MULTISELECT SIZEGADGET'
    IF (RC = 30) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    IF RC ~= 5 THEN ok = 1
  END
  IF found.COUNT = 0 THEN DO
    IF scanhttp = 1 THEN titel = 'HTTP addresses'
    IF scanemail = 1 THEN titel = 'Email addresses'
    IF scanftp = 1 THEN titel = 'FTP addresses'
    IF scanaminet = 1 THEN titel = 'Aminet files'
    'REQUESTNOTIFY TEXT "No' titel 'found in this message." BT "_Ok"'
  END
RETURN
/*~!*/

/*!~ "ListSave" */
listsave:
  PARSE ARG soort
    DO svc = 1 TO save.count
      IF name.svc = 'NAME.'svc THEN name.svc = subj '('svc')'
      showname.svc = LEFT(name.svc,20,' ')
      show.svc = showname.svc' - 'save.svc
    END
    sep = save.count +1
    but = save.count +2
    show.sep = ''
    show.but = 'SAVE'
    show.count = save.count+2
  IF soort = 1 THEN titel = 'Select to enter a name'
  IF soort = 2 THEN titel = 'Select address to edit userdata'
  'REQUESTLIST INSTEM' show 'TITLE "'titel'" SIZEGADGET'
  IF (RC = 30) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  IF RC ~= 5 THEN DO
    selected = RESULT
    IF selected = 'SAVE' THEN DO 
      IF soort = 1 THEN DO
        CALL savehotlist
        RETURN
      END
      IF soort = 2 THEN DO
        CALL save_userdata
        RETURN
      END
    END
    DO n = 1 TO save.count
      IF selected = show.n THEN DO
        IF soort = 1 THEN DO
          'REQUESTNOTIFY TEXT "What do you want to change?" BT "_Name|_URL"'
          IF RESULT = 1 THEN DO
            'REQUESTSTRING title "Enter a name" BT "_OK|_Cancel" BODY "'save.n'" ID "'name.n'"'
            IF RC = 0 THEN name.n = RESULT
            IF RC = 5 THEN name.n = name.n
          END
          IF RESULT = 0 THEN DO
            'REQUESTSTRING title "Edit the URL" BT "_OK|_Cancel" BODY "'save.n'" ID "'save.n'"'
            IF RC = 0 THEN save.n = RESULT
            IF RC = 5 THEN save.n = save.n
          END
        END
        IF soort = 2 THEN SIGNAL userdata
      END
    END
    IF soort = 1 THEN SIGNAL listsave(1)
    IF soort = 2 THEN SIGNAL listsave(2)
  END
RETURN
/*~!*/

/*!~ "Create_DLEvent" */
create_dlevent:
ADDRESS BBSREAD
  DO event = 1 to save.count
    PARSE VAR save.event save.event '(' dir.event ')'
    EVENTSTEM.FILENAME = STRIP(save.event)
    EVENTSTEM.DIRECTORY = dir.event
    'WRITEBREVENT BBSNAME "'bbs'" EVENT' EVE_DOWNLOAD 'STEM' EVENTSTEM
    IF (RC ~= 0) THEN DO
      ADDRESS(thorport)
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
  END
RETURN
/*~!*/

/*!~ "Request_File" */
request_file:
  DROP selfile.
  'REQUESTFILE TITLE "Select file to scan." ID "'reqdir'" FP MS OUTSTEM' selfile
  IF (RC = 30) THEN DO
    'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
    CALL cleanup
  END
  IF RC = 5 THEN CALL cleanup
  IF RC = 0 THEN DO
    'OPENPROGRESS TITLE "'maintitle'" TOTAL' selfile.count 'AT "_Abort" PT "Scanning messages (0/'selfile.count')"'
    IF(RC ~= 0) THEN DO
      'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
      CALL cleanup
    END
    ELSE progressid1 = RESULT

    DO fl = 1 TO selfile.COUNT
      'UPDATEPROGRESS REQ' progressid1 'CURRENT' fl 'PT "Scanning messages ('fl'/'selfile.count')"'
      IF RC = 5 THEN CALL cleanup
      IF(RC = 30) THEN DO
        'REQUESTNOTIFY TEXT "'THOR.LASTERROR'" BT "_Ok"'
        CALL cleanup
      END
      tempfile = selfile.fl
      IF OPEN(reqtmp, tempfile, 'R') THEN DO
        CALL CLOSE(reqtmp)
        reqfile = 1
        subj = tempfile
        fromname = tempfile
        CALL main
      END
    END
  END
RETURN
/*~!*/

/*!~ "AskREQ" */
askreq:
  'REQUESTNOTIFY TEXT "Do you want to scan messages or select a file on disk?" BT "_Messages|_File|_Quit"'
  SELECT
    WHEN RESULT = 1 THEN req = ''
    WHEN RESULT = 2 THEN req = 'REQ'
    OTHERWISE CALL cleanup
  END
RETURN
/*~!*/

/*!~ "Dubbel" */
dubbel:
  scanadres = ARG(1)
  IF ARG(2) = 1 THEN domainOK = 1
  dubbel = POS(UPPER(scanadres'|'), UPPER(sumadres))
  IF (dubbel = 0 & domainOK ~= 0) THEN DO
    num = num + 1
    'UPDATEPROGRESS REQ' progressid 'PT "Searching... ('num')"'
    found.num = scanadres
    found.count = num
    sumadres = sumadres||scanadres'|'
  END
RETURN
/*~!*/

/*!~ "CheckDomain" */
checkdomain:
  adrespart = ARG(1)
  adrespart = TRANSLATE(adrespart, '/', ':')
  iptype = ARG(2)
  PARSE VAR adrespart '.' domainchk '/'
  IF iptype = 'IP' THEN domainchk = filter(domainchk,2)
  IF domainchk ~= '' THEN DO
    dom = LASTPOS('.', domainchk)
    INTERPRET "PARSE VAR domainchk . "dom" domainchk2"
    IF (Length(domainchk2) >= 2 & Length(domainchk2) <= 4) THEN domainOK = Pos(Upper(domainchk2)||'.', domains)
    ELSE domainOK = 0
  END
  ELSE domainOK = 0
RETURN
/*~!*/

/*!~ "Handle URL"*/
handle_url:
  url = ARG(1)
  drop save. name.
  CALL current_msg
  CALL msg_info
  save.1 = url  ; save.COUNT = 1
  name.1 = subj ; name.COUNT = 1
  ADDRESS(thorport)
  'REQUESTSTRING TITLE "Enter a name" BT "_OK|_Cancel" BODY "'save.1'" ID "'name.1'"'
  IF RC = 0 THEN name.1 = RESULT
  IF RC = 5 THEN EXIT
  scanhttp = 1
  CALL savehotlist
EXIT
/*~!*/

/*!~ "Syntax/Halt/Cleanup" */
SYNTAX:
SAY 'SYNTAX ERROR'
SAY 'Error 'rc' in line 'sigl': 'errortext(rc)
HALT:
cleanup:
 IF opentmp = 1 THEN CLOSE(tmp)
 IF EXISTS(tempfile) THEN IF reqfile = 0 THEN DELETE(tempfile)
 IF (progressid ~= 0) & SYMBOL('progressid') = 'VAR' THEN DO
   ADDRESS(thorport)
   'CLOSEPROGRESS REQ' progressid
 END
 IF (progressid1 ~= 0) & SYMBOL('progressid1') = 'VAR' THEN DO
   ADDRESS(thorport)
   'CLOSEPROGRESS REQ' progressid1
 END
 IF (pbsave ~= 0) & SYMBOL('pbsave') = 'VAR' THEN DO
   ADDRESS(thorport)
   'CLOSEPROGRESS REQ' pbsave
 END
EXIT
/*~!*/
/*~!*/

